const express = require("express");
const router = express.Router();
const User = require("../models/user");

router.post("/signUp", function(req, res, next) {
  var user = new User();
  user.id = req.body.user.id;
  user.password = req.body.user.password;
  user.name = req.body.user.name;
  user.email = req.body.user.email;
  user.isLoggedIn = req.body.user.isLoggedIn;

  user.save(function(err) {
    if (err) {
      console.error(err);
      res.json({ result: 0 });
      return;
    }
    res.json({ result: 1 });
  });
});

router.post("/checkLogin", function(req, res, next) {
  var sess = req.session;

  User.findOne(
    { id: req.body.user.id, password: req.body.user.password },
    function(err, user) {
      if (err) return res.status(500).json({ error: err });
      // User가 없으면 error
      if (!user) return res.status(404).json({ error: "user not found" });
      sess.logined = true;
      sess.userid = req.body.user.id;
      res.json(user);
    }
  );
});

router.get("/logout", function(req, res) {
  var sess = req.session;
  if (sess.userid) {
    req.session.destroy(function(err) {
      if (err) {
        console.log(err);
      } else {
        console.log("Hello");
        res.redirect("http://localhost:8081/"); // 수정해야 할 듯
      }
    });
  } else {
    res.redirect("http://localhost:8081/");
  }
});

router.get("/checkSession", function(req, res) {
  var sess = req.session;
  if (sess.userid) res.json(true);
  else {
    res.json(false);
  }
});

module.exports = router;
